'!
' * @author Copyright (c) 2008-2023 PortSIP Solutions,Inc. All rights reserved.
' * @version 19
' * @see https://www.portsip.com
' * @brief PortSIP SDK Callback events.
' 
' PortSIP VoIP SDK Callback events description.
' 



Imports System.Collections.Generic
Imports System.Text



Namespace PortSIP
    Class Session
        Private mSessionId As Integer = 0
        Private mHoldState As Boolean = False
        Private mSessionState As Boolean = False
        Private mRecvCallState As Boolean = False
        Private mOriginCallSessionId As Integer = 0
        Private mIsReferCall As Boolean = False
        Private mHasEarlyMedia As Boolean = False
        Private mDialogMessageId As Integer = 0
        Private mOutOfDialogMessageId As Integer = 0
        Private mExistsAudio As Boolean = False
        Private mExistsVideo As Boolean = False
        Private mExistsScreen As Boolean = False
        Private mInitiateScreen As Boolean = False
        Public Function hasEarlyMedia() As Boolean
            Return mHasEarlyMedia
        End Function
        Public Sub setEarlyMeida(earlyMedia As Boolean)
            mHasEarlyMedia = earlyMedia
        End Sub

        Public Function isReferCall() As Boolean
            Return mIsReferCall
        End Function

        Public Function getOriginCallSessionId() As Integer
            Return mOriginCallSessionId
        End Function

        Public Sub setReferCall(referCall As Boolean, originCallSessionId As Integer)
            mIsReferCall = referCall
            mOriginCallSessionId = originCallSessionId
        End Sub

        Public Sub setDialogMessageId(id As Integer)
            mDialogMessageId = id
        End Sub

        Public Function getDialogMessageId() As Integer
            Return mDialogMessageId
        End Function

        Public Sub setOutOfDialogMessageId(id As Integer)
            mOutOfDialogMessageId = id
        End Sub

        Public Function getOutOfDialogMessageId() As Integer
            Return mOutOfDialogMessageId
        End Function

        Public Function getExistsVideo() As Boolean
            Return mExistsVideo
        End Function

        Public Sub setExistsVide1o(state As Boolean)
            mExistsVideo = state
        End Sub
        Public Function getExistsScreen() As Boolean
            Return mExistsScreen
        End Function

        Public Sub setExistsScreen(state As Boolean)
            mExistsScreen = state
        End Sub

        Public Function getExistsAudio() As Boolean
            Return mExistsAudio
        End Function

        Public Sub setExistsAudio(state As Boolean)
            mExistsAudio = state
        End Sub

        Public Function getInitiateScreen() As Boolean
            Return mInitiateScreen
        End Function

        Public Sub setInitiateScreen(state As Boolean)
            mInitiateScreen = state
        End Sub
        Public Sub reset()
            mSessionId = 0
            mHoldState = False
            mSessionState = False
            mRecvCallState = False
            mOriginCallSessionId = 0
            mIsReferCall = False
            mDialogMessageId = 0
            mOutOfDialogMessageId = 0
            mExistsAudio = False
            mExistsVideo = False
            mExistsScreen = False
            mInitiateScreen = False
        End Sub


        Public Sub setSessionId(sessionId As Integer)
            mSessionId = sessionId
        End Sub


        Public Function getSessionId() As Integer
            Return mSessionId
        End Function

        Public Sub setHoldState(state As Boolean)
            mHoldState = state
        End Sub


        Public Function getHoldState() As Boolean
            Return mHoldState
        End Function

        Public Sub setSessionState(state As Boolean)
            mSessionState = state
        End Sub


        Public Function getSessionState() As Boolean
            Return mSessionState
        End Function



        Public Sub setRecvCallState(state As Boolean)
            mRecvCallState = state
        End Sub


        Public Function getRecvCallState() As Boolean
            Return mRecvCallState
        End Function

    End Class
End Namespace

